#ifndef _CLI_BINDED_VALUE_PARAM_H_
#define _CLI_BINDED_VALUE_PARAM_H_

#include <ast/Param.h>
#include <abstraction/ImmediateValueAbstraction.hpp>

namespace cli {

class BindedValueParam final : public Param {
	std::string m_bind;

public:
	BindedValueParam ( std::string bind ) : m_bind ( bind ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		return std::make_shared < abstraction::ImmediateValueAbstraction < std::string > > ( environment.getBinding ( m_bind ) );
	}
};

} /* namespace cli */

#endif /* _CLI_BINDED_VALUE_PARAM_H_ */
