#ifndef _CLI_VARIABLE_VALUE_PARAM_H_
#define _CLI_VARIABLE_VALUE_PARAM_H_

#include <ast/Param.h>
#include <abstraction/Registry.h>

namespace cli {

class VariableValueParam final : public Param {
	std::string m_name;

public:
	VariableValueParam ( std::string name ) : m_name ( name ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		return environment.getVariable ( m_name );
	}
};

} /* namespace cli */

#endif /* _CLI_VARIABLE_VALUE_PARAM_H_ */
